"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var requireModule_1 = require("../requireModule");
var ReactNativeWebPlugin = (function () {
    function ReactNativeWebPlugin() {
    }
    ReactNativeWebPlugin.prototype.configure = function (builder, spin) {
        var _this = this;
        var stack = builder.stack;
        if (stack.hasAll(['react-native-web', 'server', 'webpack'])) {
            var nodeExternals = requireModule_1.default('webpack-node-externals');
            var nodeExternalsFn_1 = nodeExternals({
                whitelist: [/(^webpack|^react-native)/]
            });
            builder.config = spin.merge(builder.config, {
                resolve: {
                    alias: {
                        'react-native': 'react-native-web'
                    }
                }
            });
            builder.config.externals = function (context, request, callback) {
                return nodeExternalsFn_1(context, request, function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    if (request.indexOf('react-native') >= 0) {
                        return callback(null, 'commonjs ' + request + '-web');
                    }
                    else {
                        return callback.apply(_this, args);
                    }
                });
            };
        }
    };
    return ReactNativeWebPlugin;
}());
exports.default = ReactNativeWebPlugin;
//# sourceMappingURL=ReactNativeWebPlugin.js.map